package com.fp.persistence.pgeneral.safe;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import java.util.List;
import javax.persistence.Query;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TSAFEJAVASCRIPT*/
@Entity(name = "TsafeJavaScript")
@Table(name = "TSAFEJAVASCRIPT")
public class TsafeJavaScript extends com.fp.dto.AbstractDataTransport implements Serializable, HibernateBean, Cloneable {

    /**
     * HashCode asociado con la Instancia
     */
    @Transient
    private int hashValue = 0;
    /**
     * Version de la Clase
     */
    private static final long serialVersionUID = 1L;
    /**
     * Clave primaria de la Entidad TsafeJavaScript
     */
    @EmbeddedId
    private TsafeJavaScriptKey pk;

    /**Contructor por defecto*/
    public TsafeJavaScript() {
    }

    /**Contructor de TsafeJavaScript
    @param pPk Clave Primaria del entity
     */
    public TsafeJavaScript(TsafeJavaScriptKey pPk) {
        this();
        pk = pPk;
    }

    /**
     * Metodo que entrega datos de la tabla dada la clave primaria.
     * @param pEntityManager referencia de la session a obtener datos del bean.
     * @param pKey Caleve primaria del bean.
     * @return TsafeJavaScript
     */
    public static TsafeJavaScript find(EntityManager pEntityManager, TsafeJavaScriptKey pKey) throws Exception {
        TsafeJavaScript obj = pEntityManager.find(TsafeJavaScript.class, pKey);
        return obj;
    }

    /**Entrega la Clave primaria de TsafeJavaScript
    @return El objeto que referencia a la Clave primaria de TsafeJavaScript
     */
    public TsafeJavaScriptKey getPk() {
        return pk;
    }

    /**Fija un nuevo valor a la Clave primaria de TsafeJavaScript
    @param pPk El objeto que referencia a la nueva Clave primaria de TsafeJavaScript
     */
    public void setPk(TsafeJavaScriptKey pPk) {
        pk = pPk;
    }

    public boolean equals(Object rhs) {
        if (rhs == null) {
            return false;
        }
        if (!(rhs instanceof TsafeJavaScript)) {
            return false;
        }
        TsafeJavaScript that = (TsafeJavaScript) rhs;
        if (this.getPk() == null || that.getPk() == null) {
            return false;
        }
        return (this.getPk().equals(that.getPk()));
    }

    /**Implementación del metodo hashCode de la la entidad TsafeJavaScript
    @return el hashCode la instancia
     */
    public int hashCode() {
        if (this.hashValue == 0) {
            int result = 17;
            if (this.getPk() == null) {
                result = super.hashCode();
            } else {
                result = this.getPk().hashCode();
            }
            this.hashValue = result;
        }
        return this.hashValue;
    }

    /**Implementación toString
     */
    public String toString() {
        Field[] fs = this.getClass().getDeclaredFields();
        String data = "";
        for (Field f : fs) {
            try {
                String name = f.getName();
                if (f.getType().getName().compareTo("java.util.Set") == 0) {
                    continue;
                }
                if (name.compareTo("hashValue") == 0 || name.compareTo("serialVersionUID") == 0) {
                    continue;
                }
                data += name + "=" + f.get(this) + ";";
            } catch (Exception e) {
                continue;
            }
        }
        if (data.compareTo("") == 0) {
            data = super.toString();
        }
        return data;
    }

    /**Implementación de la creación de un bean en blanco TsafeJavaScript
     */
    public Object createInstance() {
        TsafeJavaScript instance = new TsafeJavaScript();
        instance.setPk(new TsafeJavaScriptKey());
        return instance;
    }

    /**Clona la entidad TsafeJavaScript
    @see com.fp.dto.hb.HibernateBean#cloneMe()
     */
    public Object cloneMe() throws CloneNotSupportedException {
        TsafeJavaScript p = (TsafeJavaScript) this.clone();
        p.setPk((TsafeJavaScriptKey) this.pk.cloneMe());
        return p;
    }
    //METODOS MANAUALES
    private static final String HQL =
            "select tb.pk.filename from TsafeJavaScript tb  "
            + " where tb.pk.companycode = :companycode"
            + " and tb.pk.channelcode = :channelcode";

    /**
     * Metodo que devuelve los javascript a ser utilizados en la aplicacion
     * @param pEntityManager
     * @param companycode
     * @param channelcode
     * @return
     */
    public static List<String> find(EntityManager pEntityManager, Integer companycode, String channelcode) {
        List<String> lTsafeJavaScript = null;
        Query qry = pEntityManager.createQuery(HQL);
        qry.setParameter("companycode", companycode);
        qry.setParameter("channelcode", channelcode);
        lTsafeJavaScript = qry.getResultList();
        return lTsafeJavaScript;
    }
}
